/**
 * Add or remove the transparency from the text
 */
export default function toggleTextTransparency(enableTransparency) {
    if (enableTransparency) {
        const elements = document.querySelectorAll('body *:not(script):not(style)');
        elements.forEach(el => {
            el.style.setProperty('color', 'transparent', 'important');
        });
        return;
    }
    const elements = document.querySelectorAll('body [color]:not(script):not(style)');
    elements.forEach(el => {
        el.style.removeProperty('color');
    });
}
