import type { IosOffsets } from './constants.interfaces.js';
import type { ResizeDimensions } from '../methods/images.interfaces.js';
import type { TestContext } from '../commands/check.interfaces.js';
import type { DeviceRectangles } from '../methods/rectangles.interfaces.js';
export declare const DEFAULT_COMPARE_OPTIONS: {
    blockOutSideBar: boolean;
    blockOutStatusBar: boolean;
    blockOutToolBar: boolean;
    createJsonReportFiles: boolean;
    diffPixelBoundingBoxProximity: number;
    ignoreAlpha: boolean;
    ignoreAntialiasing: boolean;
    ignoreColors: boolean;
    ignoreLess: boolean;
    ignoreNothing: boolean;
    rawMisMatchPercentage: boolean;
    returnAllCompareData: boolean;
    saveAboveTolerance: number;
    scaleImagesToSameSize: boolean;
};
export declare const DEFAULT_FORMAT_STRING = "{tag}-{browserName}-{width}x{height}-dpr-{dpr}";
export declare const STORYBOOK_FORMAT_STRING = "{tag}-{logName}-{width}x{height}-dpr-{dpr}";
export declare const PLATFORMS: {
    ANDROID: string;
    IOS: string;
};
export declare const FOLDERS: {
    readonly ACTUAL: "actual";
    readonly DIFF: "diff";
    readonly TEMP_FULL_SCREEN: "tempFullScreen";
    readonly DEFAULT: {
        readonly BASE: "./__snapshots__/";
        readonly SCREENSHOTS: ".tmp/";
    };
};
export declare const DEFAULT_SHADOW: {
    ADDRESS_BAR: number;
    TOOL_BAR: number;
};
export declare const DESKTOP = "desktop";
export declare const NOT_KNOWN = "not_known";
export declare const CUSTOM_CSS_ID = "pic-css";
export declare const DEFAULT_RESIZE_DIMENSIONS: Required<ResizeDimensions>;
export declare const FULL_PAGE_SCROLL_TIMEOUT = 1500;
export declare const DEFAULT_TABBABLE_OPTIONS: {
    circle: {
        backgroundColor: string;
        borderColor: string;
        borderWidth: number;
        fontColor: string;
        fontFamily: string;
        fontSize: number;
        size: number;
        showNumber: boolean;
    };
    line: {
        color: string;
        width: number;
    };
};
export declare const DEVICE_RECTANGLES: DeviceRectangles;
export declare const ANDROID_OFFSETS: {
    6: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
    7: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
    8: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
    9: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
    10: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
    11: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
    12: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
    13: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
    14: {
        STATUS_BAR: number;
        ADDRESS_BAR: number;
        TOOL_BAR: number;
    };
};
export declare const IOS_OFFSETS: IosOffsets;
export declare const supportedIosBezelDevices: string[];
export declare const DEFAULT_TEST_CONTEXT: TestContext;
//# sourceMappingURL=constants.d.ts.map