import type { BoundingBox, IgnoreBoxes } from './images.interfaces.js';
import type { CompareData } from '../resemble/compare.interfaces.js';
import type { TestContext } from '../commands/check.interfaces.js';
export type ResultReport = {
    description: string;
    test: string;
    tag: string;
    instanceData: {
        app?: string;
        browser?: {
            name: string;
            version: string;
        };
        deviceName?: string;
        platform: {
            name: string;
            version: string;
        };
    };
    commandName: string;
    framework: string;
    boundingBoxes: {
        diffBoundingBoxes: BoundingBox[];
        ignoredBoxes: IgnoreBoxes[];
    };
    fileData: {
        actualFilePath: string;
        baselineFilePath: string;
        diffFilePath?: string;
        fileName: string;
        size: {
            actual: {
                width: number;
                height: number;
            };
            baseline: {
                width: number;
                height: number;
            };
            diff?: {
                width: number;
                height: number;
            };
        };
    };
    misMatchPercentage: string;
    rawMisMatchPercentage: number;
};
export declare function createCompareReport({ boundingBoxes, data, fileName, folders, size, testContext: { commandName, instanceData: { app, browser, deviceName, isIOS, isMobile, platform, }, framework, parent, tag, title }, }: {
    boundingBoxes: {
        diffBoundingBoxes: BoundingBox[];
        ignoredBoxes: IgnoreBoxes[];
    };
    data: CompareData;
    folders: {
        actualFolderPath: string;
        baselineFolderPath: string;
        diffFolderPath?: string;
    };
    fileName: string;
    size: {
        actual: {
            width: number;
            height: number;
        };
        baseline: {
            width: number;
            height: number;
        };
        diff?: {
            width: number;
            height: number;
        };
    };
    testContext: TestContext;
}): void;
//# sourceMappingURL=createCompareReport.d.ts.map