import type { DeviceRectangles } from './rectangles.interfaces.js';
import type { Executor, TakeElementScreenshot, TakeScreenShot } from './methods.interfaces.js';
import type { RectanglesOutput } from './rectangles.interfaces.js';
export interface FullPageScreenshotsData {
    fullPageHeight: number;
    fullPageWidth: number;
    data: ScreenshotData[];
}
interface ScreenshotData {
    canvasWidth: number;
    canvasYPosition: number;
    imageHeight: number;
    imageWidth: number;
    imageXPosition: number;
    imageYPosition: number;
    screenshot: string;
}
export interface FullPageScreenshotDataOptions {
    addressBarShadowPadding: number;
    devicePixelRatio: number;
    deviceRectangles: DeviceRectangles;
    fullPageScrollTimeout: number;
    hideAfterFirstScroll: (HTMLElement | HTMLElement[])[];
    innerHeight: number;
    isAndroid: boolean;
    isAndroidNativeWebScreenshot: boolean;
    isAndroidChromeDriverScreenshot: boolean;
    isIOS: boolean;
    isLandscape: boolean;
    screenHeight: number;
    screenWidth: number;
    toolBarShadowPadding: number;
}
export interface FullPageScreenshotNativeMobileOptions {
    addressBarShadowPadding: number;
    devicePixelRatio: number;
    deviceRectangles: DeviceRectangles;
    fullPageScrollTimeout: number;
    hideAfterFirstScroll: (HTMLElement | HTMLElement[])[];
    isAndroid: boolean;
    isLandscape?: boolean;
    innerHeight: number;
    toolBarShadowPadding: number;
    screenWidth: number;
}
export interface FullPageScreenshotOptions {
    devicePixelRatio: number;
    fullPageScrollTimeout: number;
    innerHeight: number;
    hideAfterFirstScroll: (HTMLElement | HTMLElement[])[];
}
export interface TakeWebElementScreenshot {
    devicePixelRatio?: number;
    deviceRectangles: DeviceRectangles;
    element: any;
    executor: Executor;
    fallback?: boolean;
    initialDevicePixelRatio: number;
    isEmulated: boolean;
    innerHeight?: number;
    isAndroidNativeWebScreenshot: boolean;
    isAndroid: boolean;
    isIOS: boolean;
    isLandscape: boolean;
    screenShot: TakeScreenShot;
    takeElementScreenshot?: TakeElementScreenshot;
}
export interface TakeWebElementScreenshotData {
    base64Image: string;
    isWebDriverElementScreenshot: boolean;
    rectangles: RectanglesOutput;
}
export {};
//# sourceMappingURL=screenshots.interfaces.d.ts.map